#ifndef YSMALLOC_IS_INCLUDED
#define YSMALLOC_IS_INCLUDED
/* { */

template <class T,const int minimum> class YsOneMemoryBlock
{
public:
	YsOneMemoryBlock();
	virtual ~YsOneMemoryBlock();

	T *GetMemoryBlock(int requiredSize);

protected:
	T minBuf[minimum];
	T *ptr;
};

template <class T,const int minimum>
YsOneMemoryBlock <T,minimum>::YsOneMemoryBlock()
{
	ptr=NULL;
}

template <class T,const int minimum>
YsOneMemoryBlock <T,minimum>::~YsOneMemoryBlock()
{
	if(ptr!=NULL && ptr!=minBuf)
	{
		delete [] ptr;
	}
}

template <class T,const int minimum>
T *YsOneMemoryBlock <T,minimum>::GetMemoryBlock(int requiredSize)
{
	if(ptr==NULL)
	{
		if(requiredSize<=minimum)
		{
			ptr=minBuf;
		}
		else
		{
//####
//printf("$$");
			ptr=new T[requiredSize];
			if(ptr==NULL)
			{
				YsPrintf::def->Printf
				   ("YsOneMemoryBlock::GetMemoryBlock\n"
				    "  Low Memory Warning!!\n");
			}
		}
		return ptr;
	}
	YsPrintf::def->Printf
	   ("YsOneMemoryBlock::GetMemoryBlock\n"
	    "  Attempted doubely get memory block from one YsOneMemoryBlock\n");
	return NULL;
}

/* } */
#endif
