#ifndef YSMATH_IS_INCLUDED
#define YSMATH_IS_INCLUDED
/* { */

#define YsAbs(a) ((a)>=0 ? (a) : -(a))
#define YsEqual(a,b) (YsAbs(a-b)<=YsTolerance ? YSTRUE : YSFALSE)
#define YsZero(a) YsEqual((a),0.0)
#define YsGreater(a,b) ((a)>(b) ? (a) : (b))
#define YsSmaller(a,b) ((a)<(b) ? (a) : (b))
#define YsBound(x,a,b) ((x)<(a) ? (a) : ((x)>(b) ? (b) : (x)))

#define YSBLUEIMPULSE YSLEFT_ZPLUS_YPLUS
#define YSOPENGL YSRIGHT_ZMINUS_YPLUS

const double YsPi=3.14159265358979323;
const double YsE=2.71828;

extern double YsTolerance;
extern YSCOORDSYSMODEL YsCoordSysModel;




// Declaration /////////////////////////////////////////////
class YsMath : public YsBaseClass
{
public:
	static YsClassHierarchy *ClassInfo;
	static char *ClassName;
	virtual char *WhatItIs(void){return YsMath::ClassName;}
	virtual YsClassHierarchy *Hierarchy(void){return YsMath::ClassInfo;}
	static unsigned GetLeak(void){return ClassInfo->GetLeak();}
	YsMath();
	YsMath(const YsMath &from);
	virtual ~YsMath();
};

////////////////////////////////////////////////////////////

inline double YsDegToRad(double deg)
{
	return deg*YsPi/180.0;
}

inline double YsRadToDeg(double rad)
{
	return rad*180.0/YsPi;
}

/* } */
#endif
