// This program is separated from ysadvgeometry.cpp due to
// VC++5.0's bug.

// Not to add functions that are not affected by VC++5.0's bug   > me.

#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#include "ysclass.h"



////////////////////////////////////////////////////////////

YSBOOL YsCheckInBetween2(const YsVec2 &q,const YsVec2 &p1,const YsVec2 &p2)
{
	if((p2-p1)*(q-p1)+YsTolerance>=0.0 && (p1-p2)*(q-p2)+YsTolerance>=0.0)
	{
		return YSTRUE;
	}
	else
	{
		return YSFALSE;
	}
}

////////////////////////////////////////////////////////////


YSBOOL YsCheckInBetween3(const YsVec3 &q,const YsVec3 &p1,const YsVec3 &p2)
{
// VC++5.0 Optimizer Bug here.
// Following Code doesn't work unless I turn off the optimization.
	if((p2-p1)*(q-p1)+YsTolerance>=0.0 && (p1-p2)*(q-p2)+YsTolerance>=0.0)
	{
		return YSTRUE;
	}
	else
	{
		return YSFALSE;
	}
}

////////////////////////////////////////////////////////////

YSSIDE YsCheckInsidePolygon3(const YsVec3 &pnt,int np,const YsVec3 p[])
{
	int i,j,k,CrossCounter,vt1,vt2;
	YsVec3 crs,vec;

	YsVec3 ray,hpn,avn;
	YsPlane hip;        // Half Infinite Plane  (Used instead of thin ray beam)


	YsGetAverageNormalVector(avn,np,p);
	if(avn.GetSquareLength()<YsTolerance)
	{
		return YSUNKNOWNSIDE;
	}


	for(i=1; i<8; i++)
	{
		for(k=0; k<np; k++)
		{
			if(p[k]==p[(k+1)%np])  // (*A)Do not confuse with *B
			{
				goto NEXTANGLE;
			}

			ray=p[k]+((p[(k+1)%np]-p[k])*double(i)/8.0)-pnt;

			if(ray.GetSquareLength()<YsTolerance)
			{
				return YSBOUNDARY;
			}

			ray.Normalize();
			hpn=ray^avn;
			if(hpn.GetSquareLength()<YsTolerance)
			{
				goto NEXTANGLE;
			}

			hip.Set(pnt,hpn);

			CrossCounter=0;
			for(j=0; j<np; j++)
			{
				vt1= j;
				vt2=(j+1)%np;

				if(pnt==p[vt1] || pnt==p[vt2])
				{
					return YSBOUNDARY;
				}

				if(p[vt1]==p[vt2]) // (*B)Do not confuse with *A
				{
					continue;
				}


				if(hip.CheckOnPlane(p[vt1])==YSTRUE ||
				   hip.CheckOnPlane(p[vt2])==YSTRUE)
				{
					goto NEXTANGLE;
				}
				else if(hip.GetPenetration(crs,p[vt1],p[vt2])==YSOK)
				{
					if(crs==pnt &&
					   YsCheckInBetween3(crs,p[vt2],p[vt1])==YSTRUE)
					{
						return YSBOUNDARY;
					}
					if(crs==p[vt1] || crs==p[vt2])
					{
						goto NEXTANGLE;
					}

					vec=crs-pnt;
					if(vec*ray>0.0 &&
					   YsCheckInBetween3(crs,p[vt1],p[vt2])==YSTRUE)
					{
						CrossCounter++;
					}
				}
			}
			if(CrossCounter%2==0)
			{
				return YSOUTSIDE;
			}
			else
			{
				return YSINSIDE;
			}

		NEXTANGLE:
			;
		}
    }
	YsPrintf::def->Printf("YsCheckInsidePolyg2\nWarning\n");
	return YSUNKNOWNSIDE;
}

