#include <stdio.h>
#include <stdarg.h>

#include "ysprintf.h"


// Implementation //////////////////////////////////////////
YsClassHierarchy *YsPrintf::ClassInfo=NULL;
char *YsPrintf::ClassName="YsPrintf";

YsPrintf::YsPrintf()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
}

YsPrintf::YsPrintf(const YsPrintf &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsPrintf::~YsPrintf()
{
	ClassInfo->Release();
}

void YsPrintf::Output(char str[])
{
	printf("%s",str);
}

int YsPrintf::Printf(const char *fmt,...)
{
	int a;
	char buf[4096];
	va_list arg_ptr;

	va_start(arg_ptr,fmt);
	a=vsprintf(buf,fmt,arg_ptr);
	va_end(arg_ptr);

	if(this!=NULL)
	{
		Output(buf);
	}
	else
	{
		printf("%s",buf);
	}
	return a;
}

YsPrintf *YsPrintf::def=NULL;

void YsPrintf::SetDefault(void)
{
	def=this;
}
