#include "ysclass.h"

// Implementation //////////////////////////////////////////
YsClassHierarchy *YsProperty::ClassInfo=NULL;
char *YsProperty::ClassName="YsProperty";

YsProperty::YsProperty()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
}

YsProperty::YsProperty(const YsProperty &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsProperty::~YsProperty()
{
	ClassInfo->Release();
}

// Implementation //////////////////////////////////////////
YsClassHierarchy *YsColor::ClassInfo=NULL;
char *YsColor::ClassName="YsColor";

YsColor::YsColor()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsProperty::ClassInfo);
	}
	ClassInfo->Allocate();
	R=0;
	G=0;
	B=1.0;
}

YsColor::YsColor(const YsColor &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsProperty::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsColor::YsColor(double rr,double gg,double bb)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsProperty::ClassInfo);
	}
	ClassInfo->Allocate();
	R=rr;
	G=gg;
	B=bb;
}

YsColor::~YsColor()
{
	ClassInfo->Release();
}

void YsColor::Set(int c15bit)
{
	unsigned c;
	c=c15bit & 32767;
	G=double((c>>10)&31)/31.0;
	R=double((c>> 5)&31)/31.0;
	B=double((c    )&31)/31.0;
}

void YsColor::Set(int rr,int gg,int bb)
{
	R=double(rr)/255.0;
	G=double(gg)/255.0;
	B=double(bb)/255.0;
}

void YsColor::Set(double rr,double gg,double bb)
{
	R=rr;
	G=gg;
	B=bb;
}

int YsColor::Get15BitColor(void) const
{
	int g,r,b;
	g=int(G*255.0);
	r=int(R*255.0);
	b=int(B*255.0);
	return ((g*31/255)<<10)+((r*31/255)<<5)+(b*31/255);
}

void YsColor::GetIntRGB(int &rr,int &gg,int &bb) const
{
	rr=int(R*255.0);
	gg=int(G*255.0);
	bb=int(B*255.0);
}

void YsColor::GetDoubleRGB(double &rr,double &gg,double &bb) const
{
	rr=R;
	gg=G;
	bb=B;
}

