//Let's prevent direct access to YsShellPolygon or YsShellVertex
//from outside of YsShell. (Other than freeAttributes)
//Application must access to those properties through YsShell.
//That's only way I can put transformation
//matrix for each shell.



#define YS_COMPILING_YSSHELL_CPP


#include "ysclass.h"
#include "ysshell.h"




//####
//#include <impulse.h>
//extern BIPOSATT expoViewpoint;
//extern YsShell *shellToDraw1,*shellToDraw2;
//void DrawShell(YsShell &shell,int id);
//####





// Implementation //////////////////////////////////////////
YsClassHierarchy *YsShellItem::ClassInfo=NULL;
char *YsShellItem::ClassName="YsShellItem";

YsShellItem::YsShellItem()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();

	freeAttribute0=0;
	freeAttribute1=0;
	freeAttribute2=0;
	freeAttribute3=0;
	freeAttribute4=0;
}

YsShellItem::YsShellItem(const YsShellItem &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsShellItem::~YsShellItem()
{
	ClassInfo->Release();
}

// Implementation //////////////////////////////////////////
YsClassHierarchy *YsShellVertex::ClassInfo=NULL;
char *YsShellVertex::ClassName="YsShellVertex";

YsShellVertex::YsShellVertex()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsShellItem::ClassInfo);
	}
	ClassInfo->Allocate();
	usedBy=NULL;
}

YsShellVertex::YsShellVertex(const YsShellVertex &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsShellItem::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsShellVertex::~YsShellVertex()
{
	ClassInfo->Release();
}

YSRESULT YsShellVertex::AddUsedBy(int plId)
{
	int i;
	for(i=0; i<usedBy.GetNumItem(); i++)
	{
		if(usedBy.GetItem(i)==plId)
		{
			return YSOK;
		}
	}
	return usedBy.AppendItem(plId);
}

YSRESULT YsShellVertex::DeleteUsedBy(int plId)
{
	int k,x;
	int i,*p,np;

	YsOneMemoryBlock <int,16> memBlock;

	np=usedBy.GetNumItem();
	p=memBlock.GetMemoryBlock(np);


	if(p!=NULL)
	{
		k=0;
		for(i=0; i<np; i++)
		{
			x=usedBy.GetItem(i);
			if(x!=plId)
			{
				p[k++]=x;
			}
		}
		usedBy.Set(k,p);

		return YSOK;
	}
	else
	{
		YsPrintf::def->Printf
		    ("YsShellVertex::DeleteUsedBy\nLow Memory Warning!!\n");
		return YSERR;
	}
}

YSRESULT YsShellVertex::SetPosition(const YsVec3 &p)
{
	pos=p;
	return YSOK;
}

YSRESULT YsShellVertex::AfterDeletePolygon(int deletedPlId)
{
	int x;
	int i,np;

	np=usedBy.GetNumItem();

	for(i=0; i<np; i++)
	{
		x=usedBy.GetItem(i);
		if(x>deletedPlId)
		{
			usedBy.SetItem(i,x-1);
		}
	}
	return YSOK;
}


const YsVec3 &YsShellVertex::GetPosition(void) const
{
	return pos;
}

// Implementation //////////////////////////////////////////
YsClassHierarchy *YsShellPolygon::ClassInfo=NULL;
char *YsShellPolygon::ClassName="YsShellPolygon";

YsShellPolygon::YsShellPolygon()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsShellItem::ClassInfo);
	}
	ClassInfo->Allocate();
}

YsShellPolygon::YsShellPolygon(const YsShellPolygon &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsShellItem::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsShellPolygon::~YsShellPolygon()
{
	ClassInfo->Release();
}

void YsShellPolygon::Invert(void)
{
	int i,n,a,b;
	n=idx.GetNumItem();
	for(i=0; i<n/2; i++)
	{
		a=idx.GetItem(i);
		b=idx.GetItem(n-1-i);
		idx.SetItem(i,b);
		idx.SetItem(n-1-i,a);
	}
	nom=-nom;
}

// Implementation //////////////////////////////////////////
YsClassHierarchy *YsShell::ClassInfo=NULL;
char *YsShell::ClassName="YsShell";

YsShell::YsShell()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
	plg=NULL;
	vtx=NULL;
}

YsShell::YsShell(const YsShell &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsShell::~YsShell()
{
	ClassInfo->Release();
	if(plg!=NULL)
	{
		plg->DeleteList();
	}
	if(vtx!=NULL)
	{
		vtx->DeleteList();
	}
}

void YsShell::CleanUp(void)
{
	if(plg!=NULL)
	{
		plg->DeleteList();
		plg=NULL;
	}
	if(vtx!=NULL)
	{
		vtx->DeleteList();
		vtx=NULL;
	}
}

void YsShell::Encache(void) const
{
	if(plg!=NULL)
	{
		plg->Encache();
	}
	if(vtx!=NULL)
	{
		vtx->Encache();
	}
}

int YsShell::AddVertex(const YsVec3 &vec)
{
	YsList <YsShellVertex> *neo;
	neo=new YsList <YsShellVertex>;
	if(neo!=NULL)
	{
		neo->dat.SetPosition(vec);
		vtx=vtx->Append(neo);
		vtx->Encache();
		return neo->GetPositionInList();
	}
	else
	{
		YsPrintf::def->Printf("YsShell::AddVertex\nLowMemoryWarning\n");
		return -1;
	}
}

int YsShell::AddPolygon(int nv,const int v[])
{
	YsList <YsShellPolygon> *neo;
	neo=new YsList <YsShellPolygon>;
	if(neo!=NULL)
	{
		int i,plId;
		neo->dat.idx.Set(nv,v);

		plg=plg->Append(neo);
		plg->Encache();
		plId=neo->GetPositionInList();

		for(i=0; i<nv; i++)
		{
			GetVertex(v[i])->AddUsedBy(plId);
		}
		return plId;
	}
	else
	{
		YsPrintf::def->Printf("YsShell::AddPolygon\nLowMemoryWarning\n");
		return -1;
	}
}

YSRESULT YsShell::ModifyPolygon
    (int plId,const int nv,const int v[],YSBOOL autoUpdateUsedBy)
{
	YsShellPolygon *plg;
	YsShellVertex *vtx;
	plg=GetPolygon(plId);
	if(plg!=NULL)
	{
		int i,nVtxOld;
		nVtxOld=GetNumVertexOfPolygon(plId);

		if(autoUpdateUsedBy==YSTRUE)
		{
			for(i=0; i<nVtxOld; i++)
			{
				vtx=GetVertex(plg->idx.GetItem(i));
				vtx->DeleteUsedBy(plId);
			}

			for(i=0; i<nv; i++)
			{
				vtx=GetVertex(v[i]);
				vtx->AddUsedBy(plId);
			}
		}

		plg->idx.Set(nv,v);

		return YSOK;
	}
	return YSERR;
}

YSRESULT YsShell::ApplyVtIdConversionTable
    (int nEntry,const int tab[],YSBOOL autoUpdateUsedBy)
{
	if(nEntry<GetNumVertex())
	{
		return YSERR;
	}


	int nVt,*vtId;
	YsOneMemoryBlock <int,8192> memBlock;
	vtId=memBlock.GetMemoryBlock(GetMaxNumVertexOfPolygon());



	int plId,nPlg;
	nPlg=GetNumPolygon();
	for(plId=0; plId<nPlg; plId++)
	{
		nVt=GetNumVertexOfPolygon(plId);
		if(GetVertexListOfPolygon(vtId,nVt,plId)==YSOK)
		{
			int i;
			for(i=0; i<nVt; i++)
			{
				vtId[i]=tab[vtId[i]];
			}
			ModifyPolygon(plId,nVt,vtId,autoUpdateUsedBy);
		}
	}

	return YSOK;
}

YSRESULT YsShell::ValidateVtId(int nVtId,const int vtId[]) const
{
	int i,nVtx;
	nVtx=GetNumVertex();
	for(i=0; i<nVtId; i++)
	{
		if(nVtx<=vtId[i])
		{
			return YSERR;
		}
	}
	return YSOK;
}

YSRESULT YsShell::ValidatePlId(int nPlId,const int plId[]) const
{
	int i,nPlg;
	nPlg=GetNumVertex();
	for(i=0; i<nPlId; i++)
	{
		if(nPlg<=plId[i])
		{
			return YSERR;
		}
	}
	return YSOK;
}

int YsShell::AddPolygonVertex(int nv,const YsVec3 v[])
{
	return AddPolygonVertex(nv,v,-1,NULL);
}

YSRESULT YsShell::ModifyVertexPosition(int vtId,const YsVec3 &neoPos)
{
	YsShellVertex *vtx;
	vtx=GetVertex(vtId);
	if(vtx!=NULL)
	{
		vtx->SetPosition(neoPos);
		return YSOK;
	}
	return YSERR;
}

int YsShell::AddPolygonVertex(int nv,const YsVec3 v[],int fa3,const int fa4[])
{
	int i,*vtId,plId;
	YsOneMemoryBlock <int,256> memBlock;
	YsShellVertex *vtx;

	vtId=memBlock.GetMemoryBlock(nv);


	if(vtId!=NULL)
	{
		for(i=0; i<nv; i++)
		{
			vtId[i]=AddVertex(v[i]);
			if(fa3>=0 && fa4!=NULL)
			{
				vtx=GetVertex(vtId[i]);
				vtx->freeAttribute3=fa3;
				vtx->freeAttribute4=fa4[i];
			}
		}
		plId=AddPolygon(nv,vtId);

		return plId;
	}
	else
	{
		YsPrintf::def->Printf("YsShell::AddPolygonVertex\nLowMemoryWarning\n");
		return -1;
	}
}

YSRESULT YsShell::GetNormalOfPolygon(YsVec3 &nom,int plId) const
{
	YsList <YsShellPolygon> *plgPtr;
	plgPtr=plg->Seek(plId);
	if(plgPtr!=NULL)
	{
		nom=plgPtr->dat.nom;
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsShell::GetColorOfPolygon(YsColor &col,int plId) const
{
	YsList <YsShellPolygon> *plgPtr;
	plgPtr=plg->Seek(plId);
	if(plgPtr!=NULL)
	{
		col=plgPtr->dat.col;
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsShell::SetNormalOfPolygon(int plId,const YsVec3 &nom)
{
	YsShellPolygon *plg;
	plg=GetPolygon(plId);
	if(plg!=NULL)
	{
		plg->nom=nom;
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsShell::SetColorOfPolygon(int plId,const YsColor &col)
{
	YsShellPolygon *plg;
	plg=GetPolygon(plId);
	if(plg!=NULL)
	{
		plg->col=col;
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsShell::DeleteVertex(int vtId,YSBOOL autoUpdateVtIdOfPolygon)
{
	int i;
	YsShellVertex *v;
	v=GetVertex(vtId);
	if(v!=NULL)
	{
		if(autoUpdateVtIdOfPolygon==YSTRUE)
		{
			if(v->usedBy.GetNumItem()>0)
			{
				YsPrintf::def->Printf("YsShell::DeleteVertex\n"
				             "Tried to delete a Vertex in use (%d)\n",vtId);
				for(i=0; i<v->usedBy.GetNumItem(); i++)
				{
					YsPrintf::def->Printf(" Used by(%d)\n",
					    v->usedBy.GetItem(i));
				}
				return YSERR;
			}

			int nVtx;
			int *table,YsIntBuf[8192];

			nVtx=GetNumVertex();
			if(nVtx<8192)
			{
				table=YsIntBuf;
			}
			else
			{
				table=new int[nVtx];
			}

			for(i=0; i<nVtx; i++)
			{
				table[i]=(i<=vtId ? i : i-1);
			}

			ApplyVtIdConversionTable(GetNumVertex(),table,YSFALSE);
			  // Note:Turn off automatic update of YsShellVertex::usedBy,
			  //      because invalid polygons temporariliy occurs
			  //      before vertex is actually deleted,

			if(table!=YsIntBuf)
			{
				delete [] table;
			}
		}

		YsList <YsShellVertex> *ptr;
		ptr=vtx->Seek(vtId);
		vtx=ptr->DeleteFromList();
		vtx->Encache();

		return YSOK;
	}
	return YSERR;
}

YSRESULT YsShell::DeletePolygon(int plId,YSBOOL autoUpdateUsedBy)
{
	YsShellPolygon *p;
	YsShellVertex *vtx;
	p=GetPolygon(plId);

	if(p!=NULL)
	{
		int i,nVtx;

		if(autoUpdateUsedBy==YSTRUE)
		{
			nVtx=GetNumVertexOfPolygon(plId);

			for(i=0; i<nVtx; i++)
			{
				vtx=GetVertex(p->idx.GetItem(i));
				vtx->DeleteUsedBy(plId);
			}
		}

		YsList <YsShellPolygon> *ptr;
		ptr=plg->Seek(plId);
		plg=ptr->DeleteFromList();
		plg->Encache();


		if(autoUpdateUsedBy==YSTRUE)
		{
			nVtx=GetNumVertex();
			for(i=0; i<nVtx; i++)
			{
				vtx=GetVertex(i);
				vtx->AfterDeletePolygon(plId);
			}
		}

		return YSOK;
	}
	return YSERR;
}

YSRESULT YsShell::DeleteVertexAtTheSamePosition(void)
{
	int nDeleted;
	return DeleteVertexAtTheSamePosition(nDeleted);
}

YSRESULT YsShell::DeleteVertexAtTheSamePosition(int &nDeleted)
{
	int nVtx;
	int nToDelete,*toDelete;
	int nTable,*table;
	YsOneMemoryBlock <int,8192> memBlock1;
	YsOneMemoryBlock <int,8192> memBlock2;

	Encache();

	nVtx=GetNumVertex();

	toDelete=memBlock1.GetMemoryBlock(nVtx);
	table=memBlock2.GetMemoryBlock(nVtx);

	int i,j;
	YsVec3 v1,v2;
	for(i=0; i<nVtx; i++)
	{
		table[i]=i;
	}
	nTable=nVtx;

	nToDelete=0;
	for(i=0; i<nVtx; i++)
	{
		if(table[i]==i)
		{
			GetVertexPosition(v1,i);
			for(j=i+1; j<nVtx; j++)
			{
				GetVertexPosition(v2,j);
				if(v1==v2)
				{
					table[j]=i;
					toDelete[nToDelete++]=j;
				}
			}
		}
	}


	for(i=0; i<nToDelete; i++)
	{
		int target;
		target=toDelete[i];
		if(DeleteVertex(target,YSFALSE)==YSOK)
		{
			for(j=i+1; j<nToDelete; j++)
			{
				if(toDelete[j]>target)
				{
					toDelete[j]--;
				}
			}
			for(j=0; j<nTable; j++)
			{
				if(table[j]>target)
				{
					table[j]--;
				}
			}
		}
	}

	ApplyVtIdConversionTable(nTable,table,YSFALSE);

	RefreshVertexReferenceTable();

	nDeleted=nToDelete;

	return YSOK;
}

const YsShell &YsShell::operator=(const YsShell &from)
{
	if(this!=&from)
	{
		YsList <YsShellPolygon> *neoPlg;
		YsList <YsShellVertex> *neoVtx;

		neoPlg=from.plg->Duplicate();
		if(from.plg!=NULL && neoPlg==NULL)
		{
			YsPrintf::def->Printf("YsShell::operator=\n"
			    "Low Memory Warning!!\n");
			goto FAILED;
		}

		neoVtx=from.vtx->Duplicate();
		if(from.vtx!=NULL && neoVtx==NULL)
		{
			neoPlg->DeleteList();
			YsPrintf::def->Printf("YsShell::operator=\n"
			    "Low Memory Warning!!\n");
			goto FAILED;
		}

		plg->DeleteList();
		vtx->DeleteList();

		plg=neoPlg;
		vtx=neoVtx;
		mat=from.mat;
	}
FAILED:
	return *this;
}

int YsShell::GetNumPolygon(void) const
{
	return plg->GetNumObject();
}

YsShellPolygon *YsShell::GetPolygon(int id)
{
	YsList <YsShellPolygon> *seeker;
	seeker=plg->Seek(id);
	if(seeker!=NULL)
	{
		return &seeker->dat;
	}
	else
	{
		return NULL;
	}
}

const YsShellPolygon *YsShell::GetPolygon(int id) const
{
	const YsList <YsShellPolygon> *seeker;
	seeker=plg->Seek(id);
	if(seeker!=NULL)
	{
		return &seeker->dat;
	}
	else
	{
		return NULL;
	}
}

void YsShell::GetBoundingBox(YsVec3 &min,YsVec3 &max)
{
	if(vtx!=NULL)
	{
		YsList <YsShellVertex> *seeker;
		YsBoundingBoxMaker3 bbx;

		bbx.Begin(vtx->dat.pos);
		for(seeker=vtx; seeker!=NULL; seeker=seeker->Next())
		{
			bbx.Add(seeker->dat.pos);
		}
		bbx.Get(min,max);
	}
	else
	{
		min.Set(0.0,0.0,0.0);
		max.Set(0.0,0.0,0.0);
	}
}

int YsShell::GetNumVertex(void) const
{
	return vtx->GetNumObject();
}

int YsShell::GetMaxNumVertexOfPolygon(void) const
{
	int n,t;
	int i;
	n=0;
	for(i=0; i<GetNumPolygon(); i++)
	{
		t=GetNumVertexOfPolygon(i);
		n=YsGreater(n,t);
	}
	return n;
}

YSRESULT YsShell::GetVertexPosition(YsVec3 &pos,int vtId) const
{
	const YsShellVertex *vtx;
	vtx=GetVertex(vtId);
	if(vtx!=NULL)
	{
		pos=mat*vtx->GetPosition();
		return YSOK;
	}
	else
	{
		return YSERR;
	}
}

YsShellVertex *YsShell::GetVertex(int id)
{
	YsList <YsShellVertex> *seeker;
	seeker=vtx->Seek(id);
	if(seeker!=NULL)
	{
		return &seeker->dat;
	}
	else
	{
		return NULL;
	}
}

const YsShellVertex *YsShell::GetVertex(int id) const
{
	const YsList <YsShellVertex> *seeker;
	seeker=vtx->Seek(id);
	if(seeker!=NULL)
	{
		return &seeker->dat;
	}
	else
	{
		return NULL;
	}
}

int YsShell::GetNumVertexOfPolygon(int plId) const
{
	const YsList <YsShellPolygon> *seeker;
	seeker=plg->Seek(plId);

	if(seeker!=NULL)
	{
		return seeker->dat.idx.GetNumItem();
	}
	else
	{
		return 0;
	}
}

YSRESULT YsShell::GetVertexListOfPolygon
    (int idx[],int maxcount,int plId) const
{
	YsList <YsShellPolygon> *seeker;
	seeker=plg->Seek(plId);
	if(seeker!=NULL)
	{
		int i,nVtId;
		nVtId=seeker->dat.idx.GetNumItem();

		for(i=0; i<nVtId && i<maxcount; i++)
		{
			idx[i]=seeker->dat.idx.GetItem(i);
		}
		if(nVtId<=maxcount)
		{
			return YSOK;
		}
	}
	return YSERR;
}

YSRESULT YsShell::GetVertexListOfPolygon
    (YsVec3 v[],int maxcount,int plId) const
{
	YsList <YsShellPolygon> *seeker;
	seeker=plg->Seek(plId);
	if(seeker!=NULL)
	{
		int i,nVtId,vtId;
		nVtId=seeker->dat.idx.GetNumItem();

		for(i=0; i<nVtId && i<maxcount; i++)
		{
			vtId=seeker->dat.idx.GetItem(i);
			const YsShellVertex *vtxSeeker;
			vtxSeeker=GetVertex(vtId);
			if(vtxSeeker!=NULL)
			{
				v[i]=mat*vtxSeeker->GetPosition();
			}
			else
			{
				return YSERR;
			}
		}
		if(nVtId<=maxcount)
		{
			return YSOK;
		}
	}
	return YSERR;
}

const int *YsShell::GetVertexListOfPolygon(int plId) const
{
	YsList <YsShellPolygon> *seeker;
	seeker=plg->Seek(plId);
	if(seeker!=NULL)
	{
		return seeker->dat.idx.GetArray();
	}
	return NULL;
}

void YsShell::SetMatrix(const YsMatrix4x4 &m)
{
	mat=m;
}

void YsShell::GetMatrix(YsMatrix4x4 &m) const
{
	m=mat;
}

YSSIDE YsShell::CountRayIntersection
    (int &CrossCounter,const YsVec3 &org,const YsVec3 &vec,int plIdSkip) const
{
	int i;
	int nVtx;
	YsVec3 vtx[256],crs;
	YsPlane pln;

	CrossCounter=0;

//####
//printf("\n++++++++\n");
//####

	for(i=0; i<GetNumPolygon(); i++)
	{
		if(i==plIdSkip)
		{
			continue;
		}

		nVtx=GetNumVertexOfPolygon(i);
		GetVertexListOfPolygon(vtx,256,i);

		if(pln.MakeBestFitPlane(nVtx,vtx)!=YSOK)
		{
			YsPrintf::def->Printf(
			    "YsShell::CountRayIntersection\n"
			    "Skipping Bad polygon(%d)\n",i);
			continue;
		}

		if(pln.GetIntersection(crs,org,vec)==YSOK)
		{


//####
//printf("F!\n");
//if(BiKey(BIKEY_SHIFT)==BI_ON)
//{
//BiClearScreen();
//BiStartBuffer(&expoViewpoint);
//BIPOINT p;
//BiSetPoint(&p,org.x(),org.y(),org.z());
//BiInsMarker(&p,&BiWhite,BIMK_RECT);
//BiSetPoint(&p,crs.x(),crs.y(),crs.z());
//BiInsMarker(&p,&BiWhite,BIMK_CROSS);
//BiSetPoint(&p,(org+vec).x(),(org+vec).y(),(org+vec).z());
//BiInsMarker(&p,&BiWhite,BIMK_CIRCLE);
//DrawShell(*this,i);
//BiFlushBuffer();
//BiSwapBuffers();
//}
//####

			if(crs==org)
			{
				YSSIDE side;
				side=YsCheckInsidePolygon3(crs,nVtx,vtx);
				if(side==YSBOUNDARY || side==YSINSIDE)
				{
//####
//printf("AA\n");
					return YSBOUNDARY;
				}
			}
			else if(vec*(crs-org)>=0.0)
			{
				YSSIDE side;
				side=YsCheckInsidePolygon3(crs,nVtx,vtx);
				if(side==YSBOUNDARY || side==YSUNKNOWNSIDE)
				{
//####
//printf("BB\n");
					return YSUNKNOWNSIDE;
				}
				if(side==YSINSIDE)
				{
//####
//printf("BB+\n");
					CrossCounter++;
				}
			}
		}
		else if(pln.CheckOnPlane(org)==YSTRUE)
		{
			YSSIDE side;
			side=YsCheckInsidePolygon3(org,nVtx,vtx);
			if(side==YSBOUNDARY || side==YSINSIDE)
			{
//####
//printf("CC\n");
				return YSBOUNDARY;
			}
		}

//####
//while(BiKey(BIKEY_SHIFT)==BI_ON && BiInkey()!=BIKEY_SPACE)BiUpdateDevice();

	}

//####
//printf("DD %d\n",CrossCounter);

	if(CrossCounter%2==0)
	{
		return YSOUTSIDE;
	}
	else
	{
		return YSINSIDE;
	}
}

YSSIDE YsShell::CheckInsideSolid(const YsVec3 &pnt) const
{
	int c;
	double h,p;
	YsVec3 vec;
	int CrossCounter;

	YSSIDE side;

	h=YsDegToRad(0);
	p=YsDegToRad(-90);
	for(c=0; c<256; c++)
	{
		vec.Set(cos(p)*cos(h),sin(p),cos(p)*sin(h));

		side=CountRayIntersection(CrossCounter,pnt,vec);

		if(side!=YSUNKNOWNSIDE)
		{
			return side;
		}

		p+=YsDegToRad(30.0);
		h+=YsDegToRad(95.0);
	}

	YsPrintf::def->Printf("YsShell::IsInsideSolid\nWarning\n");
	return YSUNKNOWNSIDE;
}

YSRESULT YsShell::InvertPolygon(int plId)
{
	YsShellPolygon *plg;
	plg=GetPolygon(plId);
	if(plg!=NULL)
	{
		plg->Invert();
		return YSOK;
	}
	return YSERR;
}

int YsShell::ShootRay
    (YsVec3 &intersect,const YsVec3 &p1,const YsVec3 &vec) const
{
	int plId;
	int nVtx;
	YsVec3 vtx[256],p2;

	p2=p1+vec;

	int possiblePlId;
	double possibleDistance;
	YsVec3 possibleCollidePoint;

	possiblePlId=-1;
	possibleDistance=(p2-p1).GetSquareLength();
	possibleCollidePoint.Set(0.0,0.0,0.0);

	for(plId=0; plId<GetNumPolygon(); plId++)
	{
		if((nVtx=GetNumVertexOfPolygon(plId))>=3 &&
		    GetVertexListOfPolygon(vtx,256,plId)==YSOK)
		{
			YsVec3 o,n,i;
			YsPlane pln;
			if(YsGetAverageNormalVector(n,nVtx,vtx)==YSOK)
			{
				o=vtx[0];
				pln.Set(o,n);
				if(pln.GetPenetration(i,p1,p2)==YSOK)
				{
					YSSIDE side;
					side=YsCheckInsidePolygon3(i,nVtx,vtx);
					if((side==YSINSIDE || side==YSBOUNDARY) &&
					   (p1-i).GetSquareLength()<possibleDistance)
					{
						possibleDistance=(p1-i).GetSquareLength();
						possibleCollidePoint=i;
						possiblePlId=plId;
					}
				}
			}
		}
	}

	if(possiblePlId>=0)
	{
		intersect=possibleCollidePoint;
	}

	return possiblePlId;
}

void YsShell::ShootRay
    (YsArray <YsVec3> &intersect,const YsVec3 &p1,const YsVec3 &vec) const
{
	int plId;
	int nVtx;
	YsVec3 vtx[256],p2;

	p2=p1+vec;

	intersect.Set(0,NULL);

	for(plId=0; plId<GetNumPolygon(); plId++)
	{
		if((nVtx=GetNumVertexOfPolygon(plId))>=3 &&
		    GetVertexListOfPolygon(vtx,256,plId)==YSOK)
		{
			YsVec3 o,n,i;
			YsPlane pln;
			if(YsGetAverageNormalVector(n,nVtx,vtx)==YSOK)
			{
				o=vtx[0];
				pln.Set(o,n);
				if(pln.GetPenetration(i,p1,p2)==YSOK)
				{
					YSSIDE side;
					side=YsCheckInsidePolygon3(i,nVtx,vtx);
					if(side==YSINSIDE || side==YSBOUNDARY)
					{
						intersect.AppendItem(i);
					}
				}
			}
		}
	}
}


YSRESULT YsShell::BeginReadSrf(void)
{
	CleanUp();
	srfReadMode=0;
	srfReadPlId=0;
	return YSOK;
}

YSRESULT YsShell::ReadSrfOneLine(char str[])
{
	int ac;
	char *av[64];

	if(YsArguments(&ac,av,64,str)==YSOK)
	{
		if(srfReadMode==0)  // Reading Vertices or other commands
		{
			YsVec3 v;
			switch(str[0])
			{
			case 'S': // SURF
			case 's':
				break;
			case 'V': // VERTEX
			case 'v':
				v.Set(atof(av[1]),atof(av[2]),atof(av[3]));
				AddVertex(v);
				break;
			case 'E': // END
			case 'e':
				break;
			case 'F': // FACE
			case 'f':
				srfReadMode=1;
				break;
			}
			return YSOK;
		}
		else // Reading Face
		{
			int i;
			YsArray <int> vtLst;
			switch(str[0])
			{
			case 'C': // COLOR
			case 'c':
				srfReadColor.Set(atoi(av[1]));
				break;
			case 'N': // CENTER & NORMAL
			case 'n':
				srfReadNom.Set(atof(av[4]),atof(av[5]),atof(av[6]));
				break;
			case 'V': // VERTEX
			case 'v':
				for(i=1; i<ac; i++)
				{
					vtLst.AppendItem(atoi(av[i]));
				}
				srfReadPlId=AddPolygon(vtLst.GetNumItem(),vtLst.GetArray());
				break;
			case 'E': // ENDFACE
			case 'e':
				SetNormalOfPolygon(srfReadPlId,srfReadNom);
				SetColorOfPolygon(srfReadPlId,srfReadColor);
				break;
			}
		}
	}
	return YSOK;
}

YSRESULT YsShell::EndReadSrf(void)
{
	return YSOK;
}

YSRESULT YsShell::LoadSrf(char fn[])
{
	FILE *fp;
	char buf[256];
	fp=fopen(fn,"r");
	if(fp!=NULL)
	{
		BeginReadSrf();
		while(fgets(buf,256,fp)!=NULL)
		{
			if(ReadSrfOneLine(buf)!=YSOK)
			{
				fclose(fp);
				return YSERR;
			}
		}
		EndReadSrf();
		fclose(fp);
		return YSOK;
	}
	return YSERR;
}

////////////////////////////////////////////////////////////

YSBOOL YsCheckShellCollision(YsShell &sh1,YsShell &sh2)
{
	YSBOOL result;
	int i,j,np1,np2,nv1,nv2;
	YsShellPolygon *pl1,*pl2;
	YsVec3 v1[256],v2[256];
	YsCollisionOfPolygon wizard;

	np1=sh1.GetNumPolygon();
	np2=sh2.GetNumPolygon();

	for(i=0; i<np1; i++)
	{
		pl1=sh1.GetPolygon(i);
		pl1->freeAttribute3=0;
	}
	for(i=0; i<np2; i++)
	{
		pl2=sh2.GetPolygon(i);
		pl2->freeAttribute3=0;
	}

	result=YSFALSE;
	for(i=0; i<np1; i++)
	{
		nv1=sh1.GetNumVertexOfPolygon(i);
		sh1.GetVertexListOfPolygon(v1,256,i);
		pl1=sh1.GetPolygon(i);
		wizard.SetPolygon1(nv1,v1);

		for(j=0; j<np2; j++)
		{
			nv2=sh2.GetNumVertexOfPolygon(j);
			sh2.GetVertexListOfPolygon(v2,256,j);
			wizard.SetPolygon2(nv2,v2);

			if(wizard.CheckCollision()==YSTRUE)
			{
				pl2=sh2.GetPolygon(j);
				pl1->freeAttribute3=1;
				pl2->freeAttribute3=1;
				result=YSTRUE;
			}
		}
	}

	return result;
}





static YSRESULT YsBlendShell1to2
    (YsShell &newShell,
     const YsShell &sh1,const YsShell &sh2,int f,YSBOOL elimOverlap)
{
	int i,j,np1,np2,nv1,nv2,plId;
	const YsShellPolygon *pl1;
	YsShellPolygon *plNew;
	YsVec3 v1[256],v2[256];
	int vtId[256];
	YsCollisionOfPolygon wizard;
	YsSword sword;

	np1=sh1.GetNumPolygon();
	np2=sh2.GetNumPolygon();

	for(i=0; i<np1; i++)
	{
		nv1=sh1.GetNumVertexOfPolygon(i);
		sh1.GetVertexListOfPolygon(v1,256,i);
		sh1.GetVertexListOfPolygon(vtId,256,i);
		pl1=sh1.GetPolygon(i);
		wizard.SetPolygon1(nv1,v1);
		sword.SetInitialPolygon(nv1,v1,vtId);

		for(j=0; j<np2; j++)
		{
			nv2=sh2.GetNumVertexOfPolygon(j);
			sh2.GetVertexListOfPolygon(v2,256,j);
			wizard.SetPolygon2(nv2,v2);

			if(wizard.CheckOnTheSamePlane()==YSTRUE)
			{
				sword.SlashByOverlappingPolygon3(nv2,v2,j);
			}
			else if(wizard.CheckCollision()==YSTRUE)
			{
				sword.Slash(nv2,v2);
			}
		}

		int nPiece;
		const YsArray <YsVec3> *plg;
		const YsArray <int> *vtId;

		nPiece=sword.GetNumPolygon();
		for(j=0; j<nPiece; j++)
		{
			int slashedPlId;
			if(sword.IsFromOverlappingPolygon3(j,slashedPlId)!=YSTRUE)
			{
				plg=sword.GetPolygon(j);
				vtId=sword.GetVertexIdList(j);
				plId=newShell.AddPolygonVertex
				    (plg->GetNumItem(),plg->GetArray(),f,vtId->GetArray());
				plNew=newShell.GetPolygon(plId);
				plNew->col=pl1->col;
				plNew->nom=pl1->nom;
				plNew->freeAttribute2=f;
				plNew->freeAttribute3=i;
				plNew->freeAttribute4=0;
			}
			else if(elimOverlap!=YSTRUE)
			{
				plg=sword.GetPolygon(j);
				plId=newShell.AddPolygonVertex
				    (plg->GetNumItem(),plg->GetArray());
				plNew=newShell.GetPolygon(plId);
				plNew->col=pl1->col;
				plNew->nom=pl1->nom;
				plNew->freeAttribute2=2;   //2 means shared polygon
				plNew->freeAttribute3=i;
				plNew->freeAttribute4=slashedPlId;
			}
		}
	}
	return YSOK;
}

YSBOOL YsShell::AdjustBlendedPolygon(int &nv,int v[])
{
	for(int i=0; i<nv; i++)
	{
		int j,k,l;
		j=(i+1)%nv;
		k=(i+2)%nv;
		if(v[i]==v[k])
		{
			if(j>k)
			{
				int a;
				a=j;
				j=k;
				k=a;
			}
			for(l=k; l<nv; l++)
			{
				v[l]=v[l+1];
			}
			nv--;
			for(l=j; l<nv; l++)
			{
				v[l]=v[l+1];
			}
			nv--;
			return YSTRUE;
		}
	}
	return YSFALSE;
}


// Note: vtIdNew must not be equal to vtIdOrg
YSRESULT YsShell::BlendPolygonVtId
    (int &nvNew,int vtIdNew[],int nBuf,
     int nv1,const int vtId1[],int nv2,const int vtId2[])
{
	if(nBuf<nv2+nv1)
	{
		return YSERR;
	}

	int i;
	int vtOrg1,vtOrg2,vt1,vt2;

	for(i=0; i<nv1; i++)
	{
		vtOrg1=vtId1[i];
		vtOrg2=vtId1[(i+1)%nv1];
		for(int j=0; j<nv2; j++)
		{
			vt1=vtId2[j];
			vt2=vtId2[(j+1)%nv2];
			if(vt1==vtOrg1 && vt2==vtOrg2)
			{
				int n;

				n=0;
				for(int k=0; k<nv1; k++)
				{
					vtIdNew[n++]=vtId1[(i+1+k)%nv1];
				}
				for(int l=1; l<nv2-1; l++)
				{
					vtIdNew[n++]=vtId2[(j+nv2-l)%nv2];
				}
				nvNew=n;

				while(AdjustBlendedPolygon(nvNew,vtIdNew)==YSTRUE)
				{
				}

				return YSOK;
			}
			else if(vt1==vtOrg2 && vt2==vtOrg1)
			{
				int n;

				n=0;
				for(int k=0; k<nv1; k++)
				{
					vtIdNew[n++]=vtId1[(i+1+k)%nv1];
				}
				for(int l=1; l<nv2-1; l++)
				{
					vtIdNew[n++]=vtId2[(j+1+l)%nv2];
				}
				nvNew=n;

				while(AdjustBlendedPolygon(nvNew,vtIdNew)==YSTRUE)
				{
				}

				return YSOK;
			}
		}
	}
	return YSERR;
}


YSRESULT YsShell::OmitPolygonAfterBlend(void)
{
	int i,j;
	YsOneMemoryBlock <int,8192> memBlock;
	int nVtxNew,*vtxNew,nVtxOfShell;
	int stopInifiniteLoop;

	stopInifiniteLoop=256;

	nVtxOfShell=GetNumVertex();
	vtxNew=memBlock.GetMemoryBlock(nVtxOfShell);

REPEAT:

	for(i=0; i<GetNumPolygon(); i++)
	{
		for(j=i+1; j<GetNumPolygon(); j++)
		{
			YsShellPolygon *plg1,*plg2;
			int nVtx1;
			const int *vtx1;
			int nVtx2;
			const int *vtx2;

			plg1=GetPolygon(i);
			nVtx1=plg1->idx.GetNumItem();
			vtx1=plg1->idx.GetArray();

			plg2=GetPolygon(j);
			nVtx2=plg2->idx.GetNumItem();
			vtx2=plg2->idx.GetArray();

			if(plg1!=NULL && plg2!=NULL &&
               plg1->freeAttribute2==plg2->freeAttribute2 &&
               plg1->freeAttribute3==plg2->freeAttribute3)
			{
				if(BlendPolygonVtId
				    (nVtxNew,vtxNew,nVtxOfShell,nVtx1,vtx1,nVtx2,vtx2)==YSOK)
				{
					if(ModifyPolygon(i,nVtxNew,vtxNew,YSFALSE)==YSOK)
					{
						DeletePolygon(j,YSFALSE);
					}

					if(stopInifiniteLoop>0)
					{
						stopInifiniteLoop--;
						goto REPEAT;
					}
					else
					{
						goto FINISH;
					}
				}
			}
		}
	}

FINISH:
	RefreshVertexReferenceTable();

	return YSOK;
}

YSRESULT YsShell::RefreshVertexReferenceTable(void)
{
	int plId,vtId;
	int nVtxOfShell;
	int nPlgOfShell,nVtxOfPlg;
	YsShellVertex *vtx;
	YsShellPolygon *plg;

	YSBOOL *refreshed;

	nVtxOfShell=GetNumVertex();
	nPlgOfShell=GetNumPolygon();

	refreshed=new YSBOOL [nVtxOfShell];

	if(refreshed!=NULL)
	{
		for(vtId=0; vtId<nVtxOfShell; vtId++)
		{
			refreshed[vtId]=YSFALSE;
		}

		for(plId=0; plId<nPlgOfShell; plId++)
		{
			plg=GetPolygon(plId);
			nVtxOfPlg=GetNumVertexOfPolygon(plId);
			for(vtId=0; vtId<nVtxOfPlg; vtId++)
			{
				vtx=GetVertex(plg->idx.GetItem(vtId));
				if(vtx!=NULL)
				{
					if(refreshed[plId]==YSFALSE)
					{
						vtx->usedBy.Set(1,&plId);
					}
					else
					{
						vtx->AddUsedBy(plId);
					}
				}
				else
				{
					YsPrintf::def->Printf
					        ("YsShell::RefreshVertexReferenceTable\n"
					         "Invalid VtId is detected. (2)\n");
				}
			}
		}

		for(plId=0; plId<nVtxOfShell; plId++)
		{
			if(refreshed[plId]==YSFALSE)
			{
				vtx=GetVertex(plId);
				vtx->usedBy.Set(0,NULL);
			}
		}
	}
	else
	{
		for(vtId=0; vtId<nVtxOfShell; vtId++)
		{
			vtx=GetVertex(vtId);
			vtx->usedBy.Set(0,NULL);
		}

		for(plId=0; plId<nPlgOfShell; plId++)
		{
			plg=GetPolygon(plId);
			nVtxOfPlg=GetNumVertexOfPolygon(plId);
			for(vtId=0; vtId<nVtxOfPlg; vtId++)
			{
				vtx=GetVertex(plg->idx.GetItem(vtId));
				if(vtx!=NULL)
				{
					vtx->AddUsedBy(plId);
				}
				else
				{
					YsPrintf::def->Printf
					        ("YsShell::RefreshVertexReferenceTable\n"
					         "Invalid VtId is detected. (1)\n");
				}
			}
		}
	}

	if(refreshed!=NULL)
	{
		delete refreshed;
	}

	return YSOK;
}

static YSBOOL YsSharedPolygonIsBoundary
    (YsShell &newShell,int sharedPlId,
     const YsShell &sh1,int fromPlId1,
     const YsShell &sh2,int fromPlId2)
{
	int nVtxOfPlg,crsCtr1,crsCtr2;
	YsOneMemoryBlock <YsVec3,256> mem;
	YsVec3 *vtx,nom1,nom2;
	YsVec3 lat,lng,inside,ray;
	YSSIDE side1,side2;

	double factor[9][2]=
	{
		{ 0.0, 0.0},
		{ 1.0, 0.0},
		{ 1.0, 1.0},
		{ 0.0, 1.0},
		{-1.0, 1.0},
		{-1.0, 0.0},
		{-1.0,-1.0},
		{ 0.0,-1.0},
		{ 1.0,-1.0}
	};

	nVtxOfPlg=newShell.GetNumVertexOfPolygon(sharedPlId);
	vtx=mem.GetMemoryBlock(nVtxOfPlg);

	if(vtx!=NULL)
	{
		int k;

		newShell.GetVertexListOfPolygon(vtx,nVtxOfPlg,sharedPlId);
		YsGetAverageNormalVector(nom1,nVtxOfPlg,vtx);
		nom1.Normalize();
		nom2=-1.0*nom1;

		YsGetArbitraryInsidePointOfPolygon3(inside,nVtxOfPlg,vtx);

		lat=nom1.GetArbitraryParpendicularVector();
		lng=nom2^lat;

		lat.Normalize();
		lng.Normalize();

		for(k=0; k<9; k++)
		{
			ray=nom1+lat*factor[k][0]+lng*factor[k][1];

			side1=sh1.CountRayIntersection(crsCtr1,inside,ray,fromPlId1);
			side2=sh2.CountRayIntersection(crsCtr2,inside,ray,fromPlId2);

			if(side1!=YSBOUNDARY && side1!=YSUNKNOWNSIDE &&
			   side2!=YSBOUNDARY && side2!=YSUNKNOWNSIDE)
			{
				if((crsCtr1%2)==(crsCtr2%2))
				{
					return YSTRUE;
				}
				else
				{
					return YSFALSE;
				}
			}
		}
	}

	YsPrintf::def->Printf
	    ("YsPolygonIsInside()@ysshell.cpp\n"
	     "  Overlapping polygon may exists.\n");
	return YSTRUE;
}

static YSRESULT YsBlendAnd
    (YsShell &newShell,const YsShell &sh1,const YsShell &sh2)
{
	int i;
	int nVtx;
	YsVec3 vtx[256],cen;

//####
printf("AND1\n");

	newShell.Encache();

	for(i=newShell.GetNumPolygon()-1; i>=0; i--)
	{
		YsShellPolygon *plg;
		plg=newShell.GetPolygon(i);
		nVtx=newShell.GetNumVertexOfPolygon(i);
		newShell.GetVertexListOfPolygon(vtx,256,i);

		YsGetArbitraryInsidePointOfPolygon3(cen,nVtx,vtx);

		if((plg->freeAttribute2==0 && sh2.CheckInsideSolid(cen)!=YSINSIDE)||
		   (plg->freeAttribute2==1 && sh1.CheckInsideSolid(cen)!=YSINSIDE))
		{
			newShell.DeletePolygon(i);
		}
		else if(plg->freeAttribute2==2)
		{
			if(YsSharedPolygonIsBoundary
			       (newShell,i,
			        sh1,plg->freeAttribute3,
			        sh2,plg->freeAttribute4)!=YSTRUE)
			{
				newShell.DeletePolygon(i);
			}
		}
	}
	newShell.DeleteVertexAtTheSamePosition();
	newShell.OmitPolygonAfterBlend();
//####
printf("AND8\n");
	return YSOK;
}





static YSRESULT YsBlendOr
    (YsShell &newShell,const YsShell &sh1,const YsShell &sh2)
{
	int i;
	int nVtx;
	YsVec3 vtx[256],cen;

//####
printf("OR1\n");

	newShell.Encache();

	for(i=newShell.GetNumPolygon()-1; i>=0; i--)
	{
		YsShellPolygon *plg;
		plg=newShell.GetPolygon(i);
		nVtx=newShell.GetNumVertexOfPolygon(i);
		newShell.GetVertexListOfPolygon(vtx,256,i);

		YsGetArbitraryInsidePointOfPolygon3(cen,nVtx,vtx);
		if((plg->freeAttribute2==0 && sh2.CheckInsideSolid(cen)==YSINSIDE)||
		   (plg->freeAttribute2==1 && sh1.CheckInsideSolid(cen)==YSINSIDE))
		{
			newShell.DeletePolygon(i);
		}
		else if(plg->freeAttribute2==2)
		{
			if(YsSharedPolygonIsBoundary
			       (newShell,i,
			        sh1,plg->freeAttribute3,
			        sh2,plg->freeAttribute4)!=YSTRUE)
			{
				newShell.DeletePolygon(i);
			}
		}
	}
	newShell.DeleteVertexAtTheSamePosition();
	newShell.OmitPolygonAfterBlend();

//####
printf("OR8\n");

	return YSOK;
}

static YSRESULT YsBlendMinus
    (YsShell &newShell,const YsShell &sh1,const YsShell &sh2)
{
	int i;
	int nVtx;
	YsVec3 vtx[256],cen;

//####
printf("MINUS1\n");

	newShell.Encache();

	for(i=newShell.GetNumPolygon()-1; i>=0; i--)
	{
		YsShellPolygon *plg;
		plg=newShell.GetPolygon(i);
		nVtx=newShell.GetNumVertexOfPolygon(i);
		newShell.GetVertexListOfPolygon(vtx,256,i);

		YsGetArbitraryInsidePointOfPolygon3(cen,nVtx,vtx);
		if((plg->freeAttribute2==0 && sh2.CheckInsideSolid(cen)==YSINSIDE)||
		   (plg->freeAttribute2==1 && sh1.CheckInsideSolid(cen)!=YSINSIDE))
		{
			newShell.DeletePolygon(i);
		}
		else if(plg->freeAttribute2==2)
		{
			if(YsSharedPolygonIsBoundary
			       (newShell,i,
			        sh1,plg->freeAttribute3,
			        sh2,plg->freeAttribute4)==YSTRUE)
			{
				newShell.DeletePolygon(i);
			}
		}
		else if(plg->freeAttribute2==1)
		{
			newShell.InvertPolygon(i);
		}
	}

	newShell.DeleteVertexAtTheSamePosition();
	newShell.OmitPolygonAfterBlend();

//####
printf("MINUS11\n");

	return YSOK;
}

////////////////////////////////////////////////////////////

YSRESULT YsBlendShell
   (YsShell &newShell,const YsShell &sh1,const YsShell &sh2,
    YSBOOLEANOPERATION boolop)
    // Note:This function will use freeAttribute2 and 3.
{
//####
printf("BLEND1\n");
	newShell.CleanUp();
	sh1.Encache();
	sh2.Encache();
//####
printf("BLEND2\n");

	if(YsBlendShell1to2(newShell,sh1,sh2,0,YSFALSE)==YSOK &&
	   YsBlendShell1to2(newShell,sh2,sh1,1,YSTRUE)==YSOK)
	{
		switch(boolop)
		{
		case YSBOOLBLEND:
			// It's done.
			return YSOK;
		case YSBOOLAND:
			return YsBlendAnd(newShell,sh1,sh2);
		case YSBOOLOR:
			return YsBlendOr(newShell,sh1,sh2);
		case YSBOOLMINUS:
			return YsBlendMinus(newShell,sh1,sh2);
		}
		return YSOK;
	}
//####
printf("BLEND3\n");
	return YSERR;
}


YSRESULT YsSeparateShell
    (YsShell &sh1,YsShell &sh2,const YsShell &org,const YsShell &ref)
{
	sh1.CleanUp();
	sh2.CleanUp();

	if(YsBlendShell1to2(sh1,org,ref,0,YSFALSE)==YSOK &&
	   YsBlendShell1to2(sh1,ref,org,1,YSTRUE)==YSOK)
	{
		sh2=sh1;
		if(YsBlendMinus(sh1,org,ref)==YSOK &&
		   YsBlendAnd(sh2,org,ref)==YSOK)
		{
			return YSOK;
		}
	}
	return YSERR;
}
