#include "ysclass.h"


YsSwordPolygonAttr::YsSwordPolygonAttr()
{
	isOverlappingPolygon=YSFALSE;
}

// Implementation //////////////////////////////////////////
YsClassHierarchy *YsSwordPolygon::ClassInfo=NULL;
char *YsSwordPolygon::ClassName="YsSwordPolygon";

YsSwordPolygon::YsSwordPolygon()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
}

YsSwordPolygon::YsSwordPolygon(const YsSwordPolygon &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsSwordPolygon::~YsSwordPolygon()
{
	ClassInfo->Release();
}

// Implementation //////////////////////////////////////////
YsClassHierarchy *YsSwordNewVertexLog::ClassInfo=NULL;
char *YsSwordNewVertexLog::ClassName="YsSwordNewVertexLog";

YsSwordNewVertexLog::YsSwordNewVertexLog()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();

	freeAttribute=0;
	betweenVt1=0;
	betweenVt2=0;
	idCreated=0;
}

YsSwordNewVertexLog::YsSwordNewVertexLog(const YsSwordNewVertexLog &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsBaseClass::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsSwordNewVertexLog::~YsSwordNewVertexLog()
{
	ClassInfo->Release();
}

// Implementation //////////////////////////////////////////
YsClassHierarchy *YsSword::ClassInfo=NULL;
char *YsSword::ClassName="YsSword";

const YsSword &YsSword::operator=(const YsSword &from)
{
	// Forbidden
	return *this;
}

YsSword::YsSword()
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsWizard::ClassInfo);
	}
	ClassInfo->Allocate();
	plg=NULL;
	cre=NULL;
	newCreateId=-1;
}

YsSword::YsSword(const YsSword &from)
{
	if(ClassInfo==NULL)
	{
		ClassInfo=new YsClassHierarchy;
		ClassInfo->classname=WhatItIs();
		ClassInfo->SetIsChildOf(YsWizard::ClassInfo);
	}
	ClassInfo->Allocate();
	*this=from;
}

YsSword::~YsSword()
{
	ClassInfo->Release();
	if(plg!=NULL)
	{
		plg->DeleteList();
	}
	if(cre!=NULL)
	{
		cre->DeleteList();
	}
}

int YsSword::GetNumPolygon(void) const
{
	return plg->GetNumObject();
}

int YsSword::GetNumVertexOfPolygon(int id) const
{
	const YsArray <YsVec3> *plg;
	plg=GetPolygon(id);
	if(plg!=NULL)
	{
		return plg->GetNumItem();
	}
	return 0;
}

const YsArray <YsVec3> *YsSword::GetPolygon(int i) const
{
	YsList <YsSwordPolygon> *seeker;
	seeker=plg->Seek(i);
	if(seeker!=NULL)
	{
		return &seeker->dat.plg;
	}
	else
	{
		return NULL;
	}
}

const YsArray <int> *YsSword::GetVertexIdList(int i) const
{
	YsList <YsSwordPolygon> *seeker;
	seeker=plg->Seek(i);
	if(seeker!=NULL)
	{
		return &seeker->dat.vtId;
	}
	else
	{
		return NULL;
	}
}

int YsSword::GetNumNewVertex(void) const
{
	return cre->GetNumObject();
}

const YsSwordNewVertexLog *YsSword::GetNewVertexLog(int i) const
{
	YsList <YsSwordNewVertexLog> *seeker;
	seeker=cre->Seek(i);
	if(seeker!=NULL)
	{
		return &seeker->dat;
	}
	else
	{
		return NULL;
	}
}

YSRESULT YsSword::SetInitialPolygon(int np,const YsVec3 p[],const int id[])
{
	if(plg!=NULL)
	{
		plg->DeleteList();
		plg=NULL;
	}
	if(cre!=NULL)
	{
		cre->DeleteList();
		cre=NULL;
	}
	newCreateId=-1;

	if(YsGetPolygonProjectionMatrix(plgPrjMatrix,np,p)==YSOK)
	{
		YsList <YsSwordPolygon> *neo;
		neo=new YsList <YsSwordPolygon>;
		if(neo!=NULL)
		{
			int i;
			for(i=0; i<np; i++)
			{
				YsVec3 prj3;
				YsVec2 prj2;
				prj3=plgPrjMatrix*p[i];
				prj2.Set(prj3.x(),prj3.y());
				if(neo->dat.prj.AppendItem(prj2)!=YSOK)
				{
					delete neo;
					return YSERR;
				}
			}

			if(neo->dat.plg.Set(np,p)!=YSOK)
			{
				delete neo;
				return YSERR;
			}

			if(id!=NULL && neo->dat.vtId.Set(np,id)!=YSOK)
			{
				delete neo;
				return YSERR;
			}

			plg=plg->Append(neo);
			return YSOK;
		}
	}
	return YSERR;
}

YSRESULT YsSword::GetVertexListOfPolygon(YsVec3 vec[],int maxcount,int id) const
{
	const YsArray <YsVec3> *plg;
	plg=GetPolygon(id);
	if(plg!=NULL)
	{
		int i;
		for(i=0; i<plg->GetNumItem() && i<maxcount; i++)
		{
			vec[i]=plg->GetItem(i);
		}
		if(plg->GetNumItem()<=maxcount)
		{
			return YSOK;
		}
		else
		{
			return YSERR;
		}
	}
	return YSOK;
}

YSRESULT YsSword::GetVertexListOfPolygon(const YsVec3 *vec[],int maxcount,int id) const
{
	const YsArray <YsVec3> *plg;
	plg=GetPolygon(id);
	if(plg!=NULL)
	{
		int i;
		for(i=0; i<plg->GetNumItem() && i<maxcount; i++)
		{
			vec[i]=&plg->GetItem(i);
		}
		if(plg->GetNumItem()<=maxcount)
		{
			return YSOK;
		}
		else
		{
			return YSERR;
		}
	}
	return YSOK;
}

YSRESULT YsSword::SetInitialPolygon(int np,const YsVec2 p[],int const id[])
{
	int i;
	YsVec3 *p3;
	YSRESULT res;
	YsOneMemoryBlock <YsVec3,128> memBlock;

	p3=memBlock.GetMemoryBlock(np);

	if(p3!=NULL)
	{
		for(i=0; i<np; i++)
		{
			p3[i].Set(p[i].x(),p[i].y(),0.0);
		}
		res=SetInitialPolygon(np,p3,id);

		return res;
	}
	return YSERR;
}

YSRESULT YsSword::Slash(const YsVec2 &org,const YsVec2 &vec)
{
	YsVec3 o3,v3;
	o3.Set(org.x(),org.y(),0.0);
	v3.Set(-vec.y(),vec.x(),0.0);
	if(v3.GetSquareLength()>YsTolerance)
	{
		YsPlane pln(o3,v3);
		Slash(pln);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSword::GetVertexListOfPolygon(YsVec2 vec[],int maxcount,int id) const
{
	const YsArray <YsVec3> *plg;
	plg=GetPolygon(id);
	if(plg!=NULL)
	{
		int i;
		for(i=0; i<plg->GetNumItem() && i<maxcount; i++)
		{
			vec[i].Set(plg->v(i).x(),plg->v(i).y());
		}
		if(plg->GetNumItem()<=maxcount)
		{
			return YSOK;
		}
		else
		{
			return YSERR;
		}
	}
	return YSOK;
}

YSRESULT YsSword::Slash(const YsPlane &pln)
{
	return SlashOnePolygon(plg,pln);
}

YSRESULT YsSword::Slash(int nv,const YsVec3 v[])
{
	YsPlane pln;
	pln.MakeBestFitPlane(nv,v);
	return SlashOnePolygon(plg,pln,nv,v);
}

YSRESULT YsSword::SlashByOverlappingPolygon3(int nv,const YsVec3 v[],int note)
{
	int i;
	YsVec3 p[4],normalOfInputPolygon;

	if(YsGetAverageNormalVector(normalOfInputPolygon,nv,v)==YSOK)
	{
		for(i=0; i<nv; i++)
		{
			p[0]=v[i       ]+normalOfInputPolygon;
			p[1]=v[(i+1)%nv]+normalOfInputPolygon;
			p[2]=v[(i+1)%nv]-normalOfInputPolygon;
			p[3]=v[i       ]-normalOfInputPolygon;
			Slash(4,p);
		}

		YsList <YsSwordPolygon> *seeker;
		YsVec3 inside;
		for(seeker=plg; seeker!=NULL; seeker=seeker->Next())
		{
			int nVtx;
			const YsVec3 *vtx;
			nVtx=seeker->dat.plg.GetNumItem();
			vtx=seeker->dat.plg.GetArray();
			if(YsGetArbitraryInsidePointOfPolygon3(inside,nVtx,vtx)==YSOK)
			{
				if(YsCheckInsidePolygon3(inside,nv,v)==YSINSIDE)
				{
					seeker->dat.attrSet.isOverlappingPolygon=YSTRUE;
					seeker->dat.attrSet.noteOverlapping=note;
				}
			}
		}
		return YSOK;
	}
	return YSERR;
}

YSBOOL YsSword::IsFromOverlappingPolygon3(int i) const
{
	int note;
	return IsFromOverlappingPolygon3(i,note);
}

YSBOOL YsSword::IsFromOverlappingPolygon3(int i,int &note) const
{
	YsList <YsSwordPolygon> *seeker;
	seeker=plg->Seek(i);
	if(seeker!=NULL)
	{
		note=seeker->dat.attrSet.noteOverlapping;
		return seeker->dat.attrSet.isOverlappingPolygon;
	}
	return YSFALSE;
}


//####
//#include <impulse.h>
//extern BIPOSATT expoViewpoint;
//extern YsShell *shellToDraw1,*shellToDraw2;
//void DrawShell(YsShell &shell,int id);


YSRESULT YsSword::SlashOnePolygon
 (YsList <YsSwordPolygon> *target,const YsPlane &pln,int nv,const YsVec3 v[])
{
	if(target==NULL)
	{
		return YSOK;
	}

	if(SlashOnePolygon(target->Next(),pln,nv,v)!=YSOK)
	{
		return YSERR;
	}

	if(nv>0 && v!=NULL)
	{
		YSINTERSECTION i;
		YsCollisionOfPolygon wiz;
		wiz.SetPolygon1(target->dat.plg.GetNumItem(),target->dat.plg.GetArray());
		wiz.SetPolygon2(nv,v);


		i=wiz.CheckPenetration();


//#### Debug Code
//printf("----Red is cut by Green\n");
//if(BiKey(BIKEY_SHIFT)==BI_ON)
//{
//BiClearScreen();
//BiStartBuffer(&expoViewpoint);
//
//DrawShell(*shellToDraw1,-1);
//DrawShell(*shellToDraw2,-1);
//
//BIPOINT tmp[256];
//int ys;
//for(ys=0; ys<nv; ys++)
//{
//BiSetPoint(&tmp[ys],v[ys].x(),v[ys].y(),v[ys].z());
//if(BiKey(BIKEY_SHIFT)==BI_ON)
//{
//printf("G:%lf %lf %lf\n",tmp[ys].x,tmp[ys].y,tmp[ys].z);
//}
//}
//BiInsPolyg(nv,tmp,&BiGreen);
//for(ys=0; ys<target->dat.plg.GetNumItem(); ys++)
//{
//BiSetPoint(&tmp[ys],
//target->dat.plg.GetItem(ys).x(),
//target->dat.plg.GetItem(ys).y(),
//target->dat.plg.GetItem(ys).z());
//if(BiKey(BIKEY_SHIFT)==BI_ON)
//{
//printf("R:%lf %lf %lf\n",tmp[ys].x,tmp[ys].y,tmp[ys].z);
//}
//}
//BiInsPolyg(target->dat.plg.GetNumItem(),tmp,&BiRed);
//
//YsVec3 org;
//pln.GetOrigin(org);
//BiSetPoint(&tmp[0],org.x(),org.y(),org.z());
//BiInsMarker(&tmp[0],&BiCyan,BIMK_CROSS);
//
//BiFlushBuffer();
//char str[256];
//BIPOINTS s={24,24};
//sprintf(str,"%d",i);
//BiDrawString2(&s,str,&BiWhite);
//BiSwapBuffers();
//while(BiInkey()!=BIKEY_SPACE)BiUpdateDevice();
//}
//####

		if((i!=YSINTERSECT && i!=YSTOUCH) ||     // Means apart
		   (i==YSTOUCH && wiz.OneEdgeLiesOnTheOtherPlane()!=YSTRUE))
		{

//####
//printf("Skip Cutting\n");

			YsArray <int> cutPointIndex;
			FindAddSlashPoint(cutPointIndex,target,pln,nv,v);
			return YSOK;  // Just make vertices and done.
		}
	}

//####
//printf("Not Skip Cutting\n");

	YsArray <int> cutPointIndex;
	FindAddSlashPoint(cutPointIndex,target,pln);

	if(cutPointIndex.GetNumItem()<2)
	{

//####
//printf("XXA\n");

		return YSOK;
	}
	else if(cutPointIndex.GetNumItem()==2)
	{

//####
//printf("XXB\n");

		// Shall I skip checking separatability?
		// No. Single line polygon or dot polygon could be generated.
		int id1,id2;
		id1=cutPointIndex.GetItem(0);
		id2=cutPointIndex.GetItem(1);
		if(YsCheckSeparatability2(
		     target->dat.prj.GetNumItem(),
		     target->dat.prj.GetArray(),
		     id1,id2)==YSTRUE)
		{
			YsList <YsSwordPolygon> *newPolygon;
			newPolygon=SeparateByTwo(target,id1,id2);
			if(newPolygon!=NULL)
			{
				plg=plg->Append(newPolygon);
				plg=target->DeleteFromList();
			}
		}
		return YSOK;
	}
	else if(cutPointIndex.GetNumItem()>=3)
	{

//####
//printf("XXC\n");

		// Oops. It must be concave polygon.
		YsList <YsSwordPolygon> *newPolygon;
		newPolygon=SeparateByMulti(target,cutPointIndex);
		if(newPolygon!=NULL)
		{
			plg=plg->Append(newPolygon);
			plg=target->DeleteFromList();
		}
		return YSOK;
	}

//####
//printf("XXD\n");

	return YSERR;
}

YSRESULT YsSword::FindAddSlashPoint
    (YsArray <int> &idx,YsList <YsSwordPolygon> *target,const YsPlane &pln,
     int nCuttingVtx,const YsVec3 *cuttingVtx)
{
	int i,vtId,n;
	YsArray <YsVec3> plg;
	YsArray <YsVec2> prj;
	YsArray <int> idLst;
	YsVec3 crs;
	const YsVec3 *v1,*v2;

	n=target->dat.plg.GetNumItem();
	vtId=0;
	for(i=0; i<n; i++)
	{
		plg.AppendItem(target->dat.plg.GetItem(i));
		prj.AppendItem(target->dat.prj.GetItem(i));
		if(target->dat.vtId.GetNumItem()==target->dat.plg.GetNumItem())
		{
			idLst.AppendItem(target->dat.vtId.GetItem(i));
		}

		if(0<target->dat.vtId.GetNumItem() &&
		   target->dat.vtId.GetNumItem()!=target->dat.plg.GetNumItem())
		{
			YsPrintf::def->Printf("YsSword::FindAddSlashPoint()\nWarning2\n");
		}

		v1=&target->dat.plg.GetItem(i);
		v2=&target->dat.plg.GetItem((i+1)%n);

		if(pln.CheckOnPlane(*v1)==YSTRUE ||
		   (pln.GetIntersection(crs,*v1,*v2-*v1)==YSOK && *v1==crs))
		{
			idx.AppendItem(vtId);
		}
		else if(pln.GetPenetration(crs,*v1,*v2)==YSOK && *v2!=crs)
		{
			YsVec3 crs3;
			YsVec2 crs2;

			if(cuttingVtx!=NULL)
			{
				YSSIDE s;
				s=YsCheckInsidePolygon3(crs,nCuttingVtx,cuttingVtx);
				if(s!=YSINSIDE && s!=YSBOUNDARY)
				{
					goto SKIP;
				}
			}

			crs3=plgPrjMatrix*crs;
			crs2.Set(crs3.x(),crs3.y());

			vtId++;
			plg.AppendItem(crs);
			prj.AppendItem(crs2);
			idx.AppendItem(vtId);
			if(0<target->dat.vtId.GetNumItem())
			{
				YsList <YsSwordNewVertexLog> *neocre,*ptr;
				for(ptr=cre; ptr!=NULL; ptr=ptr->Next())
				{
					if(ptr->dat.pos==crs)
					{
						idLst.AppendItem(ptr->dat.idCreated);
						goto ALREADYEXIST;
					}
				}

				idLst.AppendItem(newCreateId);
				neocre=new YsList <YsSwordNewVertexLog>;
				if(neocre!=NULL)
				{
					neocre->dat.betweenVt1=target->dat.vtId.GetItem(i);
					neocre->dat.betweenVt2=target->dat.vtId.GetItem((i+1)%n);
					neocre->dat.idCreated=newCreateId;
					neocre->dat.pos=crs;
					cre=cre->Append(neocre);
				}
				newCreateId--;
			ALREADYEXIST:
				;
			}
		SKIP:
			;
		}
		vtId++;
	}

	if(n<vtId)
	{
		target->dat.plg=plg;
		target->dat.prj=prj;
		if(target->dat.vtId.GetNumItem()>0)
		{
			target->dat.vtId=idLst;
			if(plg.GetNumItem()!=idLst.GetNumItem())
			{
				YsPrintf::def->Printf("YsSword::FindAddSlashPoint()\nWarning1\n");
			}
		}
	}

	return YSOK;
}

YsList <YsSwordPolygon> *YsSword::SeparateByTwo
        (YsList <YsSwordPolygon> *org,int id1,int id2)
{
	YsArray <YsVec3> plg1,plg2;
	YsArray <YsVec2> prj1,prj2;
	YsArray <int> vtId1,vtId2;

	Separate(plg1,plg2,org->dat.plg,id1,id2);
	Separate(prj1,prj2,org->dat.prj,id1,id2);
	if(org->dat.vtId.GetNumItem()==org->dat.plg.GetNumItem())
	{
		Separate(vtId1,vtId2,org->dat.vtId,id1,id2);
	}

	YsList <YsSwordPolygon> *lst1,*lst2;
	lst1=new YsList <YsSwordPolygon>;
	if(lst1!=NULL)
	{
		lst2=new YsList <YsSwordPolygon>;
		if(lst2!=NULL)
		{
			lst1->dat.plg=plg1;
			lst1->dat.prj=prj1;
			lst1->dat.vtId=vtId1;
			lst1->dat.attrSet=org->dat.attrSet;

			lst2->dat.plg=plg2;
			lst2->dat.prj=prj2;
			lst2->dat.vtId=vtId2;
			lst2->dat.attrSet=org->dat.attrSet;

			lst1=lst1->Append(lst2);
			return lst1;
		}
		delete lst1;
	}
	return NULL;
}

YsList <YsSwordPolygon> *YsSword::SeparateByMulti
	    (YsList <YsSwordPolygon> *org,YsArray <int> &cutPoint)
{
	int i,j,k,id1,id2,n;
	YsArray <YsVec3> p1,p2;
	YsArray <YsVec2> prj1,prj2;
	YsArray <int> vtId1,vtId2;
	YsArray <int> cp1,cp2;

	n=cutPoint.GetNumItem();
	for(i=0; i<n; i++)
	{
		for(j=i+1; j<n; j++)
		{
			id1=cutPoint.GetItem(i);
			id2=cutPoint.GetItem(j);  // Note: Always id1<id2
			if(id1>=id2)
			{
				YsPrintf::def->Printf("YsSword::SeparateByMulti.Warning\n");
			}
			if(YsCheckSeparatability2
			       (org->dat.prj.GetNumItem(),
			        org->dat.prj.GetArray(),
			        id1,id2)==YSTRUE)
			{
				Separate(p1,p2,org->dat.plg,id1,id2);
				Separate(prj1,prj2,org->dat.prj,id1,id2);
				if(org->dat.vtId.GetNumItem()==org->dat.plg.GetNumItem())
				{
					Separate(vtId1,vtId2,org->dat.vtId,id1,id2);
				}
				for(k=0; k<n; k++)
				{
					int x;
					x=cutPoint.GetItem(k);
					if(x<=id1)
					{
						cp1.AppendItem(cutPoint.GetItem(k));
					}
					else if(id1<=x && x<=id2)
					{
						cp2.AppendItem(cutPoint.GetItem(k)-id1);
					}
					else if(id2<=cutPoint.GetItem(k))
					{
						cp1.AppendItem(cutPoint.GetItem(k)-id2+id1+1);
					}
				}

				YsList <YsSwordPolygon> plg1,plg2,*plgLst1,*plgLst2;
				plg1.dat.plg=p1;
				plg1.dat.prj=prj1;
				plg1.dat.vtId=vtId1;

				plg2.dat.plg=p2;
				plg2.dat.prj=prj2;
				plg2.dat.vtId=vtId2;

				plgLst1=SeparateByMulti(&plg1,cp1);
				plgLst2=SeparateByMulti(&plg2,cp2);
				if(plgLst1==NULL || plgLst2==NULL)
				{
					YsPrintf::def->Printf
					    ("YsSword::SeparateByMulti()\nWarning!!\n");
				}
				plgLst1=plgLst1->Append(plgLst2);
				return plgLst1;
			}
		}
	}
	// Loopout -> means there's no other separatable combinations.
	YsList <YsSwordPolygon> *neo;
	neo=new YsList <YsSwordPolygon>;
	neo->dat.plg=org->dat.plg;
	neo->dat.prj=org->dat.prj;
	neo->dat.vtId=org->dat.vtId;
	neo->dat.attrSet=org->dat.attrSet;
	return neo;
}



YSRESULT YsSword::Triangulate(YSCONVEXNIZESTRATEGY strategy)
{
	return ConvexnizeGo(YSTRUE,plg,strategy);
}

YSRESULT YsSword::Convexnize(YSCONVEXNIZESTRATEGY strategy)
{
	return ConvexnizeGo(YSFALSE,plg,strategy);
}

YSRESULT YsSword::ConvexnizeGo
   (YSBOOL tri,YsList <YsSwordPolygon> *target,YSCONVEXNIZESTRATEGY strategy)
{
	if(target==NULL)
	{
		return YSOK;
	}

	if(ConvexnizeGo(tri,target->Next(),strategy)!=YSOK)
	{
		return YSERR;
	}

	YsList <YsSwordPolygon> *newPolygon;
	newPolygon=ConvexnizeOnePolygon(tri,target,strategy);
	if(newPolygon!=NULL && newPolygon!=target)
	{
		plg=target->DeleteFromList();
		plg=plg->Append(newPolygon);
	}

	return YSOK;
}

YsList <YsSwordPolygon> *YsSword::ConvexnizeOnePolygon
  (YSBOOL tri,YsList <YsSwordPolygon> *target,YSCONVEXNIZESTRATEGY strategy)
{
	int id1,id2;
	if(tri==YSFALSE &&
	   YsCheckConvexByAngle2(target->dat.prj.GetNumItem(),
	                       target->dat.prj.GetArray())==YSTRUE)
	{
		return target;
	}

	if(FindConvexnizeVertexPair(id1,id2,target,strategy)==YSOK)
	{
		YsList <YsSwordPolygon> *newPolygon,*plg1,*plg2,*tPlg1,*tPlg2;
		newPolygon=SeparateByTwo(target,id1,id2);

		if(newPolygon==NULL || newPolygon->Next()==NULL)
		{
			YsPrintf::def->Printf(
			    "YsSword::ConvexnizeOnePolygon()\nWarning!!\n");
			return newPolygon;
		}

		plg1=newPolygon;
		plg2=newPolygon->Next();

		tPlg2=ConvexnizeOnePolygon(tri,plg2,strategy);
		if(tPlg2!=plg2)
		{
			newPolygon=plg2->DeleteFromList();
			newPolygon=newPolygon->Append(tPlg2);
		}
		tPlg1=ConvexnizeOnePolygon(tri,plg1,strategy);
		if(tPlg1!=plg1)
		{
			newPolygon=plg1->DeleteFromList();
			newPolygon=newPolygon->Append(tPlg1);
		}
		return newPolygon;
	}
	return target;
}

YSRESULT YsSword::FindConvexnizeVertexPair
	    (int &id1,int &id2,
	     YsList <YsSwordPolygon> *target,YSCONVEXNIZESTRATEGY strategy)
{
	int i,j,n;
	double ref;
	id1=-1;
	id2=-1;
	ref=0.0;
	n=target->dat.plg.GetNumItem();
	for(i=0; i<n; i++)
	{
		for(j=i+1; j<n; j++)
		{
			if(YsCheckSeparatability2(
			    target->dat.prj.GetNumItem(),
			    target->dat.prj.GetArray(),
			    i,j)==YSTRUE)
			{
				if(strategy==YSCONVEXNIZEDEFAULT ||
				   strategy==YSCONVEXNIZENOSMALLANGLE ||
				   strategy==YSCONVEXNIZE90DEGREE)
				{
					double cosm,cos0,cos1,cos2,cos3;
					YsVec2 vij,vji,v1,v2,v3,v4;

					vij=target->dat.prj.GetItem(j)
					   -target->dat.prj.GetItem(i);
					vji=-vij;
					v1=target->dat.prj.GetItem((i+1)%n)
					  -target->dat.prj.GetItem(i);
					v2=target->dat.prj.GetItem((i+n-1)%n)
					  -target->dat.prj.GetItem(i);
					v3=target->dat.prj.GetItem((j+1)%n)
					  -target->dat.prj.GetItem(j);
					v4=target->dat.prj.GetItem((j+n-1)%n)
					  -target->dat.prj.GetItem(j);

					vij.Normalize();
					vji.Normalize();
					v1.Normalize();
					v2.Normalize();
					v3.Normalize();
					v4.Normalize();

					if(strategy==YSCONVEXNIZE90DEGREE)
					{
						cos0=YsAbs(vij*v1);
						cos1=YsAbs(vij*v2);
						cos2=YsAbs(vji*v3);
						cos3=YsAbs(vji*v4);
					}
					else
					{
						cos0=vij*v1;
						cos1=vij*v2;
						cos2=vji*v3;
						cos3=vji*v4;
					}

					cosm=YsGreater(cos0,cos1);
					cosm=YsGreater(cosm,cos2);
					cosm=YsGreater(cosm,cos3);

					cosm=2.0-cosm;  // 1.0 Redundancy
					if(ref<=cosm)
					{
						id1=i;
						id2=j;
						ref=cosm;
					}
				}
				else if(strategy==YSCONVEXNIZEFASTEST)
				{
					id1=i;
					id2=j;
					return YSOK;
				}
			}
		}
	}

	if(id1>=0 && id2>=0 && id1!=id2)
	{
		return YSOK;
	}

	return YSERR;
}


////////////////////////////////////////////////////////////
// Note:plg1->  0..id1 + id1...
//      plg2->  id1...id2
YSRESULT YsSword::Separate
	   (YsArray <YsVec3> &plg1,
	    YsArray <YsVec3> &plg2,
	    YsArray <YsVec3> &org,
	    int id1,int id2)
{
	int i,n;
	n=org.GetNumItem();
	for(i=0; i<=id1; i++)
	{
		plg1.AppendItem(org.GetItem(i));
	}
	for(i=id2; i<n; i++)
	{
		plg1.AppendItem(org.GetItem(i));
	}
	for(i=id1; i<=id2; i++)
	{
		plg2.AppendItem(org.GetItem(i));
	}
	return YSOK;
}

YSRESULT YsSword::Separate
	   (YsArray <YsVec2> &plg1,
	    YsArray <YsVec2> &plg2,
	    YsArray <YsVec2> &org,
	    int id1,int id2)
{
	int i,n;
	n=org.GetNumItem();
	for(i=0; i<=id1; i++)
	{
		plg1.AppendItem(org.GetItem(i));
	}
	for(i=id2; i<n; i++)
	{
		plg1.AppendItem(org.GetItem(i));
	}
	for(i=id1; i<=id2; i++)
	{
		plg2.AppendItem(org.GetItem(i));
	}
	return YSOK;
}

YSRESULT YsSword::Separate
	   (YsArray <int> &vtId1,
	    YsArray <int> &vtId2,
	    YsArray <int> &org,
	    int id1,int id2)
{
	int i,n;
	n=org.GetNumItem();
	for(i=0; i<=id1; i++)
	{
		vtId1.AppendItem(org.GetItem(i));
	}
	for(i=id2; i<n; i++)
	{
		vtId1.AppendItem(org.GetItem(i));
	}
	for(i=id1; i<=id2; i++)
	{
		vtId2.AppendItem(org.GetItem(i));
	}
	return YSOK;
}

